#include <iostream>
#include <fstream>
#include <cassert>

using namespace std;

const int N = 1000;
const int MAXC = 256;

int arco[N];
int num;
int l = 0;


int already[N];
int level[N];
int extend[N];

int collage( int start, int end );
void bloccaL( int n, int i );

int main(){
	int last = 0, prev = -1;
	
	ifstream fin("input.txt");
	fin >> num;
	assert( ( num > 0 ) && ( num <= N ) );

	for(int i=0; i<N;i++){
		already[i] = -1;
		level[i] = 0;
		extend[i] = 1;
	}

	// legge eliminando i doppioni consecutivi
	for( int i = 0; i < num; ++i ) {
		int app;
		fin >> app;
		if( app != prev ) {
			prev = app;
			arco[last] = app;
			++last;
		}
	}
	num = last;

	fin.close();
	collage( 0, num );
}

int collage( int start, int end){
	
	assert( ( start >= 0 ) && ( start <= num ) );
	assert( ( end >= 0 ) && ( end <= num ) );
	assert( start <= end );

	int n;
	for(int start = 0; start < end; start++){
	  	n = arco[start];
		if( already[n] == -1 ){
			// prima volta che vedo questo colore
			already[n] = 1;
			level[n] = l;
			l++;
		}else
			if(already[n] >= 1 & extend[n] == 1){
				// ho gia visto questo colore e posso estendere il suo livello
				already[n] += 1;
				bloccaL(level[n], start);
	  		}else
				if(already[n] >= 1 & extend[n] == 0){
					// ho gia trovato il numero ma non posso estendere il suo livello
					l++;
					already[n] += 1;
					level[n] = l;
					extend[n] = 1;
				}
	}
	
	ofstream fout("output.txt");
	fout << l;
	fout.close();	
		
	return l;
}

void bloccaL(int n, int start){
	// blocco i livelli successivi di n
	int app;
	for(int i = 0; i < start; i++){
		app = arco[i];	
		if( level[app] > n ){
			extend[app] = 0;
		}
	}
}
